{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 04 August 2004.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 04 August 2004

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:


-----------------------------------------------------------------------------}
unit main;

interface

uses
  Windows, Forms, 
  StdCtrls, ExtCtrls, Mask, Controls, DB, ZQuery, ZMsSqlQuery,
  ZConnect, ZMsSqlCon, Classes, ZTransact, ZMsSqlTr, ADODB, ComCtrls,
  TeEngine, Series, TeeProcs, Chart, Grids, DBGrids, Buttons;

type
  TConnectionType = (ctZEOS,ctADO);
  
  TForm1 = class(TForm)
    gbResults: TGroupBox;
    Timer1: TTimer;
    Log: TMemo;
    TopPanel: TPanel;
    gbLogin: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edHost: TEdit;
    edLogin: TEdit;
    mePassword: TMaskEdit;
    edDatabase: TEdit;
    bConnect: TButton;
    edInterval: TEdit;
    gbSQLs: TGroupBox;
    pnSQL1: TPanel;
    meSQL1: TMemo;
    Panel1: TPanel;
    cbSQL1: TCheckBox;
    pnExecuting1: TPanel;
    spSQL1: TShape;
    pnSQL3: TPanel;
    meSQL3: TMemo;
    Panel3: TPanel;
    cbSQL3: TCheckBox;
    pnExecuting3: TPanel;
    spSQL3: TShape;
    pnSQL2: TPanel;
    meSQL2: TMemo;
    Panel5: TPanel;
    cbSQL2: TCheckBox;
    pnExecuting2: TPanel;
    spSQL2: TShape;
    Panel2: TPanel;
    meSQL4: TMemo;
    Panel4: TPanel;
    cbSQL4: TCheckBox;
    Panel6: TPanel;
    spSQL4: TShape;
    PageControl1: TPageControl;
    tsMainPage: TTabSheet;
    tsChartPage: TTabSheet;
    Chart1: TChart;
    SeriesDelay: TFastLineSeries;
    rgConnectionType: TRadioGroup;
    tsViewPage: TTabSheet;
    gbSQLForView: TGroupBox;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel7: TPanel;
    sbStartSelectQuery: TSpeedButton;
    sbStopSelectQuery: TSpeedButton;
    meSQLSelect: TMemo;
    Timer2: TTimer;
    tsBlockedSelect: TTabSheet;
    GroupBox1: TGroupBox;
    Panel8: TPanel;
    sbStartSelectBlockedQuery: TSpeedButton;
    sbStopSelectBlockedQuery: TSpeedButton;
    meSQLSelectBlocked: TMemo;
    DBGrid2: TDBGrid;
    Timer3: TTimer;
    DataSource2: TDataSource;
    Label7: TLabel;
    procedure bConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbStartSelectQueryClick(Sender: TObject);
    procedure sbStopSelectQueryClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure sbStartSelectBlockedQueryClick(Sender: TObject);
    procedure sbStopSelectBlockedQueryClick(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ZMsSqlDatabase: TZMsSqlDatabase;
    ZMsSqlTransact:TZMsSqlTransact;
    ZMsSqlQuery:TZMsSqlQuery;
    ZMsSqlTransactSelect:TZMsSqlTransact;
    ZMsSqlQuerySelect:TZMsSqlQuery;
    ADOConnection: TADOConnection;
    ADOConnectionBlocked: TADOConnection;
    ADOQuery: TADOQuery;
    ADOQuerySelect: TADOQuery;
    ADOQuerySelectBlocked: TADOQuery;
    Frequency:Int64;
    SeriesCount:Integer;
    ConnectionType:TConnectionType;
    procedure ZEOSConnect;
    procedure ADOConnect;
    procedure ZEOSDisconnect;
    procedure ADODisconnect;
    procedure bDisconnectClick(Sender: TObject);
    procedure AddToLog(const Msg:string);
    procedure ReInitChart;
    procedure AddSeriesDelay(const Value:double);
    procedure SetSQLString (SQL: TStrings);
    procedure ExecSQL;
  end;

var
  Form1: TForm1;

implementation
uses SysUtils,Graphics;

{$R *.dfm}

procedure TForm1.AddToLog(const Msg: string);
begin
  Log.Lines.Add(Format('%s  %s',[TimeToStr(Now),Msg]));
end;

procedure TForm1.FormCreate(Sender: TObject);
  procedure CreateZTransact (var ZMsSqlTransact:TZMsSqlTransact;const ZMsSqlDatabase:TZMsSqlDatabase);
  begin
    ZMsSqlTransact:=TZMsSqlTransact.Create(nil);
    ZMsSqlTransact.AutoCommit:=false;
    ZMsSqlTransact.TransactSafe:=true;
    ZMsSqlTransact.Database:=ZMsSqlDatabase;
  end;
  procedure CreateZQuery (var ZMsSqlQuery:TZMsSqlQuery;const ZMsSqlTransact:TZMsSqlTransact;const ZMsSqlDatabase:TZMsSqlDatabase);
  begin
    ZMsSqlQuery:=TZMsSqlQuery.Create(nil);
    ZMsSqlQuery.Database:=ZMsSqlDatabase;
    ZMsSqlQuery.RequestLive:=false; // A false value for RequestLive (the default) causes the result set to always be read-only.
    ZMsSqlQuery.Transaction:=ZMsSqlTransact;
  end;
  procedure CreateADOConnection (var ADOConnection:TADOConnection);
  begin
    ADOConnection:=TADOConnection.Create(nil);
    ADOConnection.IsolationLevel:=ilReadCommitted; // Changes from other transactions only visible after being committed.
    ADOConnection.KeepConnection:=true; // When KeepConnection is true (the default) the connection is maintained. 
    ADOConnection.LoginPrompt:=false;
    ADOConnection.Mode:=cmReadWrite; // Read/write permissions are available to the connection.
    ADOConnection.ConnectOptions:=coConnectUnspecified; // The connection is formed synchronously.
  end;
  procedure CreateADOQuery (var ADOQuery:TADOQuery;const ADOConnection:TADOConnection);
  begin
    ADOQuery:=TADOQuery.Create(nil);
    ADOQuery.ParamCheck:=false;
    ADOQuery.MarshalOptions:=moMarshalModifiedOnly; // A value of moMarshalModifiedOnly sends back only those records that have actually been changed in the local recordset 
    ADOQuery.Connection:=ADOConnection;
    ADOQuery.CursorLocation:=clUseClient; // clUseClient a client-side cursor is used
    ADOQuery.CursorType:=ctStatic; // for clUseClient
    ADOQuery.LockType:=ltOptimistic; // only when updates are applied and a record is being updated
  end;
begin
  Randomize;
  DoubleBuffered:=true;
  // ZEOS
  ZMsSqlDatabase:=TZMsSqlDatabase.Create(nil);
  ZMsSqlDatabase.LoginPrompt:=false;
 
  CreateZTransact(ZMsSqlTransact,ZMsSqlDatabase);
  CreateZTransact(ZMsSqlTransactSelect,ZMsSqlDatabase);
  CreateZQuery(ZMsSqlQuery,ZMsSqlTransact,ZMsSqlDatabase);
  CreateZQuery(ZMsSqlQuerySelect,ZMsSqlTransactSelect,ZMsSqlDatabase);
  
  // ADO
  CreateADOConnection(ADOConnection);
  CreateADOConnection(ADOConnectionBlocked);
  ADOConnectionBlocked.Mode:=cmShareExclusive; // maximum blocking
  CreateADOQuery(ADOQuery,ADOConnection);
  CreateADOQuery(ADOQuerySelect,ADOConnection);
  CreateADOQuery(ADOQuerySelectBlocked,ADOConnectionBlocked);
  ADOQuerySelectBlocked.LockType:=ltPessimistic; // maximum blocking
  
  QueryPerformanceFrequency(Frequency);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    bDisconnectClick(Sender);
    FreeAndNil(ZMsSqlTransact);
    FreeAndNil(ZMsSqlTransactSelect);
    FreeAndNil(ZMsSqlQuery);
    FreeAndNil(ZMsSqlQuerySelect);
    FreeAndNil(ZMsSqlDatabase);
    FreeAndNil(ADOQuery);
    FreeAndNil(ADOQuerySelect);
    FreeAndNil(ADOQuerySelectBlocked);
    FreeAndNil(ADOConnection);
    FreeAndNil(ADOConnectionBlocked);
  except
  end;
end;

procedure TForm1.bConnectClick(Sender: TObject);
begin
  ReInitChart;
  try
    Timer1.Interval:=StrToInt(edInterval.Text);
  except
    edInterval.Text:='100';
    Timer1.Interval:=100;
  end;
  bConnect.Caption:='Disconnect';
  bConnect.OnClick:=bDisconnectClick;
  case rgConnectionType.ItemIndex of
    0:begin
       ConnectionType:=ctZEOS;
       ZEOSConnect;
      end;
    1:begin
        ConnectionType:=ctADO;
        ADOConnect;
      end;
  end;
  Timer1.Enabled:=true;
end;

procedure TForm1.bDisconnectClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
  bConnect.Caption:='Connect';
  bConnect.OnClick:=bConnectClick;
  case ConnectionType of
    ctZEOS:ZEOSDisconnect;
    ctADO:ADODisconnect;
  end;
end;

procedure TForm1.SetSQLString(SQL: TStrings);
begin
  case ConnectionType of
    ctZEOS:
      begin
        ZMsSqlQuery.Sql.Clear;
        ZMsSqlQuery.Sql.AddStrings(SQL);
      end;
    ctADO:
      begin
        ADOQuery.SQL.Clear;
        ADOQuery.SQL.AddStrings(SQL);
      end;
  end;
end;

procedure TForm1.ExecSQL;
begin
  case ConnectionType of
    ctZEOS:
      begin
        try
          ZMsSqlTransact.StartTransaction;
          ZMsSqlQuery.ExecSql;
          ZMsSqlTransact.Commit;
        except
          on E:Exception do
          begin
            ZMsSqlTransact.Rollback;
            AddToLog(E.Message);
          end;
        end;
      end;
    ctADO:
      begin
        try
          ADOConnection.BeginTrans;
          ADOQuery.ExecSQL;
          ADOConnection.CommitTrans;
        except
          on E:Exception do
          begin
            ADOConnection.RollbackTrans;
            AddToLog(E.Message);
          end;
        end;
      end;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  OldTimeValue,CurrTimeValue:Int64;
begin
  Timer1.Enabled:=false;
  case ConnectionType of
    ctZEOS:if not ZMsSqlDatabase.Connected then exit;
    ctADO:if not ADOConnection.Connected then exit;
  end;
  case Random(4) of
    0:
      if (cbSQL1.Checked) and (meSQL1.Lines.Text<>'') then
      begin
        SetSQLString(meSQL1.Lines);
        spSQL1.Brush.Color:=clRed;
        spSQL1.Refresh;
        try
          QueryPerformanceCounter(OldTimeValue);
          ExecSql;
          QueryPerformanceCounter(CurrTimeValue);
        except
          on E:Exception do
          begin
            AddToLog(E.Message);
          end;
        end;
        spSQL1.Brush.Color:=clMoneyGreen;
        spSQL1.Refresh;
      end;
    1:
      if (cbSQL2.Checked) and (meSQL2.Lines.Text<>'') then
      begin
        SetSQLString(meSQL2.Lines);
        spSQL2.Brush.Color:=clRed;
        spSQL2.Refresh;
        try
          QueryPerformanceCounter(OldTimeValue);
          ExecSql;
          QueryPerformanceCounter(CurrTimeValue);
        except
          on E:Exception do
          begin
            AddToLog(E.Message);
          end;
        end;
        spSQL2.Brush.Color:=clMoneyGreen;
        spSQL2.Refresh;
      end;
    2:
      if (cbSQL3.Checked) and (meSQL3.Lines.Text<>'') then
      begin
        SetSQLString(meSQL3.Lines);
        spSQL3.Brush.Color:=clRed;
        spSQL3.Refresh;
        try
          QueryPerformanceCounter(OldTimeValue);
          ExecSql;
          QueryPerformanceCounter(CurrTimeValue);
        except
          on E:Exception do
          begin
            AddToLog(E.Message);
          end;
        end;
        spSQL3.Brush.Color:=clMoneyGreen;
        spSQL3.Refresh;
      end;
    3:
      if (cbSQL4.Checked) and (meSQL4.Lines.Text<>'') then
      begin
        SetSQLString(meSQL4.Lines);
        spSQL4.Brush.Color:=clRed;
        spSQL4.Refresh;
        try
          QueryPerformanceCounter(OldTimeValue);
          ExecSql;
          QueryPerformanceCounter(CurrTimeValue);
        except
          on E:Exception do
          begin
            AddToLog(E.Message);
          end;
        end;
        spSQL4.Brush.Color:=clMoneyGreen;
        spSQL4.Refresh;
      end;
  end;
 
  AddSeriesDelay((CurrTimeValue-OldTimeValue)/Frequency);
  Timer1.Enabled:=true;
end;

procedure TForm1.ReInitChart;
begin
  Chart1.DoubleBuffered:=true;
  SeriesDelay.Clear;
  SeriesCount:=0;
end;

procedure TForm1.AddSeriesDelay(const Value: double);
begin
  SeriesDelay.AddXY(SeriesCount,Value*1000.0);
  if SeriesCount>100 then 
  begin
    SeriesDelay.Delete(0);
  end;
  Inc(SeriesCount);
end;

procedure TForm1.ADOConnect;
begin
  try
    ADOConnection.Connected:=false;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
      exit;
    end;
  end;
  try
    ADOConnection.ConnectionString:=
      Format('Provider=SQLOLEDB.1;Password=%s;Persist Security Info=True;User ID=%s;Initial Catalog=%s;Data Source=%s',
      [mePassword.Text,edLogin.Text,edDatabase.Text,edHost.Text]);
    ADOConnection.Connected:=true;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
    end;
  end;
end;

procedure TForm1.ZEOSConnect;
begin
  try
    ZMsSqlDatabase.Connected:=false;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
      exit;
    end;
  end;
  ZMsSqlDatabase.Host:=edHost.Text;
  ZMsSqlDatabase.Login:=edLogin.Text;
  ZMsSqlDatabase.Password:=mePassword.Text;
  ZMsSqlDatabase.Database:=edDatabase.Text;
  try
    ZMsSqlDatabase.Connected:=true;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
    end;
  end;
end;

procedure TForm1.ADODisconnect;
begin
  try
    ADOConnection.Connected:=false;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
    end;
  end;
end;

procedure TForm1.ZEOSDisconnect;
begin
  try
    ZMsSqlDatabase.Connected:=false;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
    end;
  end;
end;

// Select - 3rd page
procedure TForm1.sbStartSelectQueryClick(Sender: TObject);
begin
  try
    case ConnectionType of
      ctZEOS:
        begin
          if not ZMsSqlDatabase.Connected then exit;
          DataSource1.DataSet:=ZMsSqlQuerySelect;
          ZMsSqlQuerySelect.Sql.Clear;
          ZMsSqlQuerySelect.Sql.AddStrings(meSQLSelect.Lines);
          ZMsSqlQuerySelect.Active:=true;
        end;
      ctADO:
        begin
          if not ADOConnection.Connected then exit;
          DataSource1.DataSet:=ADOQuerySelect;
          ADOQuerySelect.SQL.Clear;
          ADOQuerySelect.SQL.AddStrings(meSQLSelect.Lines);
          ADOQuerySelect.Active:=true;
        end;
    end;
    sbStartSelectQuery.Enabled:=false;
    sbStopSelectQuery.Enabled:=true;
    Timer2.Enabled:=true;
  except
    on E:Exception do
    begin
      AddToLog(E.Message+' class name:'+E.ClassName);
    end;
  end;
end;

procedure TForm1.sbStopSelectQueryClick(Sender: TObject);
begin
  Timer2.Enabled:=false;
  sbStartSelectQuery.Enabled:=true;
  sbStopSelectQuery.Enabled:=false;
  try
    case ConnectionType of
      ctZEOS:
        begin
          if not ZMsSqlDatabase.Connected then exit;
          ZMsSqlQuerySelect.Active:=false;
        end;
      ctADO:
        begin
          if not ADOConnection.Connected then exit;
          ADOQuerySelect.Active:=false;
        end;
    end;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
    end;
  end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  try
    case ConnectionType of
      ctZEOS:
        begin
          if (not ZMsSqlDatabase.Connected) or (not ZMsSqlQuerySelect.Active) then 
          begin
            sbStartSelectQuery.Enabled:=true;
            sbStopSelectQuery.Enabled:=false;
            Timer2.Enabled:=false;
            exit;
          end;
          ZMsSqlQuerySelect.Close;
          ZMsSqlQuerySelect.Open;
        end;
      ctADO:
        begin
          if (not ADOConnection.Connected) or (not ADOQuerySelect.Active) then
          begin
            sbStartSelectQuery.Enabled:=true;
            sbStopSelectQuery.Enabled:=false;
            Timer2.Enabled:=false;
            exit;
          end;
          ADOQuerySelect.Close;
          ADOQuerySelect.Open;
        end;
    end;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
      Timer2.Enabled:=false;
    end;
  end;
end;

// Select with maximum blocking - 4th page
procedure TForm1.sbStartSelectBlockedQueryClick(Sender: TObject);
begin
  // only ADO
  try
    ADOConnectionBlocked.Connected:=false;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
      exit;
    end;
  end;
  try
    ADOConnectionBlocked.ConnectionString:=
      Format('Provider=SQLOLEDB.1;Password=%s;Persist Security Info=True;User ID=%s;Initial Catalog=%s;Data Source=%s',
      [mePassword.Text,edLogin.Text,edDatabase.Text,edHost.Text]);
    ADOConnectionBlocked.Connected:=true;
    ADOQuerySelectBlocked.SQL.Clear;
    ADOQuerySelectBlocked.SQL.AddStrings(meSQLSelectBlocked.Lines);
    ADOQuerySelectBlocked.Active:=true;
    DataSource2.DataSet:=ADOQuerySelectBlocked;
    sbStartSelectBlockedQuery.Enabled:=false;
    sbStopSelectBlockedQuery.Enabled:=true;
    Timer3.Enabled:=true;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
      ADOConnectionBlocked.Connected:=false;
    end;
  end;
  
end;

procedure TForm1.sbStopSelectBlockedQueryClick(Sender: TObject);
begin
  // only ADO
  Timer3.Enabled:=false;
  sbStartSelectBlockedQuery.Enabled:=true;
  sbStopSelectBlockedQuery.Enabled:=false;
  try
    ADOConnectionBlocked.Connected:=false;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
    end;
  end;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  try
    if (not ADOConnectionBlocked.Connected) or (not ADOQuerySelectBlocked.Active) then exit;
    ADOQuerySelectBlocked.Close;
    ADOQuerySelectBlocked.Open;
  except
    on E:Exception do
    begin
      AddToLog(E.Message);
      Timer3.Enabled:=false;
    end;
  end;
end;

end.
